<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/default_dune_plugin.php';
require_once 'lib/utils.php';

require_once 'lib/vod/vod_list_screen.php';
require_once 'skins/skins.php';

require_once 'Smotroon_config.php';

require_once 'Smotroon_main_menu_screen.php';
require_once 'Smotroon_exception.php';
require_once 'Smotroon_vod.php';
require_once 'Smotroon_setup_screen.php';
require_once 'Smotroon_search_history.php';
require_once 'Smotroon_vod_category_list_screen.php';
require_once 'Smotroon_vod_list_screen.php';
require_once 'Smotroon_vod_series_list_screen.php';
require_once 'Smotroon_vod_favorites_screen.php';
require_once 'Smotroon_vod_movie_screen.php';

///////////////////////////////////////////////////////////////////////////

class SmotroonPlugin extends DefaultDunePlugin
{
    private $skins;
    
    public function __construct()
    {
        if (file_exists(SmotroonConfig::SKINS_PATH) && is_dir(SmotroonConfig::SKINS_PATH))
            $this->skins = new SmotroonSkins(SmotroonConfig::PLUGIN_PATH, SmotroonConfig::SKINS_PATH);
        else
            $this->skins = new SmotroonSkins(SmotroonConfig::PLUGIN_PATH_FLASH, SmotroonConfig::SKINS_PATH_FLASH);

        $this->vod = new SmotroonVod($this->skins);

        $this->add_screen(new SmotroonMainMenuScreen($this->skins));
        $this->add_screen(new SmotroonSetupScreen($this->skins));
        $this->add_screen(new SmotroonVodCategoryListScreen($this->skins));
        $this->add_screen(new SmotroonVodListScreen($this->vod, $this->skins));
        $this->add_screen(new Smotroon_search_history($this->vod, $this->skins));
        $this->add_screen(new SmotroonVodFavoritesScreen($this->vod, $this->skins));

        $this->add_screen(new SmotroonVodMovieScreen($this->vod));
        $this->add_screen(new SmotroonVodSeriesListScreen($this->vod));
    }
}

///////////////////////////////////////////////////////////////////////////
?>
