<?php

class Mill {

    private static $v = "00:00\r46.6515.953021397";
    private static $lc;
    private static $lrc;
    private static $ahv;

    private static function init($url)
    {
        $salt = md5(self::$v);

        $domain = substr($url, 7);
        if (strpos($domain, '/') !== false)
            $domain = strstr($domain, '/', true);

        if (strpos($domain, 'www.') === 0) 
            $domain = substr($domain, 4);
        
        $parts = explode('.', $domain);

        if (count($parts) > 2)
            $domain = $parts[count($parts) - 2] . '.' . $parts[count($parts) - 1];

        self::$lc  = md5($domain . $salt);
        self::$lrc = md5($salt . $domain);
        self::$ahv = md5($salt . $domain . $salt);
    }

    private static function eval4($param)
    {
        return md5($param . self::$ahv);
    }

    private static function eval3($url, $mix) 
    {
        if (strpos($url, "?") !== false) 
            $url = substr($url, strpos($url, "?"));
                
        return md5($url . $mix . self::$ahv);
    }

    private static function checkTM($video_url)
    {
        $time = date("YmdHis");
        return "time=" . $time . "&ahv=" . self::eval3($video_url, $time) . "&cv=" . self::eval4($time);
    }

    public static function getPlaybackUrl($url, &$plugin_cookies) {
       
        $disable_ahv = false;

        if (($url = SmotroonApi::getUrlFromIframe($url)) === false)
            return false;

        $url = str_replace("&amp;","&",$url);

        hd_print("---> Getting video from mill.kz: $url\n");
        
        // Hasher init
        self::init($url);

        // Get url to XML
        $var = explode("?", $url);
        $var = $var[1];

        if (strpos($url, '?') !== false) 
            $url = strstr($url, '?', true);

        $url = substr($url, 0, strrpos($url, '/')) . '/embed.xml?';

        // Get params for XML request
        preg_match_all('/([^=&]*)=([^&]*)/', $var, $pairs);
        $pairs = array_combine($pairs[1], $pairs[2]);

        if (array_key_exists('video_id', $pairs))
            $url .= 'video_id=' . $pairs['video_id'];
        elseif (array_key_exists('video_url', $pairs))
            $url .= 'video_url=' . $pairs['video_url'];
        else
        {
            hd_print("---> Can't find 'video_id' or 'video_url' in params");
            return false;
        }

        if (array_key_exists('disable_ahv', $pairs))
            $disable_ahv = filter_var($pairs['disable_ahv'], FILTER_VALIDATE_BOOLEAN);

        // XML request
        try
        {
            $tmp = file_get_contents($url);
        }
        catch(Exception $e)
        {
            hd_print("---> Connection error!!!");
            return false;
        }

        // Get video stream URL 
        $tmp = explode('video_url="', $tmp);
        if (count ($tmp) == 1) {
            hd_print("---> Can't find 'video_url=' in XML params");
            return false;
        }
        
        $video = strstr($tmp[1], '"', true);
        $tmp = $video;

        // Add sign if needed
        if (!$disable_ahv)
        {
            if (strpos($tmp, "?") !== false)
                $tmp .= "&";
            else
                $tmp .= "?";

            $video = $tmp . self::checkTM($video);
        }

        hd_print("---> Result: " . $video);
        return $video;
   }
}