<?php

class VK {
    private static function getJsonVar($varName, $doc)
    {
        $vars = explode("var " . trim($varName) . " = {", $doc);
        if (count($vars) == 1)
            return false;

        $vars = "{" . utf8_encode(strstr($vars[1], "}", true)) . "}";

        $vars = json_decode($vars, true);
        if (json_last_error() != JSON_ERROR_NONE) {
            hd_print ('---> JSON decode error');
            return false;
        }
        return $vars;
    }

    public static function getPlaybackUrl($url, &$plugin_cookies)
    {
        hd_print('---> Video from VK: $url');

        if (($url = SmotroonApi::getUrlFromIframe($url)) === false)
            return false;

        $url = str_replace("&amp;","&",$url);

        try
        {
            $doc = HD::http_get_document($url);
        }
        catch(Exception $e)
        {
            hd_print("---> Connection error!!!");
            return false;
        }

        $vars = self::getJsonVar('vars', $doc);
        if ($vars === false)
        {
            hd_print("---> Warning! Video was deleted.");
            return false;
        }

        if (!array_key_exists('host', $vars))
        {
            $opts = self::getJsonVar('opts', $doc);

            if ($opts === false){
                hd_print("---> Unknown VK player");
                return false;
            }

            // Fake vk player
            if (strpos($opts['url'], 'ivi.ru') !== false) {
                hd_print("---> It's fake VK player - ivi.ru inside.");
                return false;
            }
            if (strpos($opts['url'], 'tvigle.ru') !== false) {
                hd_print("---> It's fake VK player - tvigle.ru inside.");
                return false;
            }

            hd_print("---> It's fake VK player - unknown inside.");
            return false;
        }
        $video_quality = isset($plugin_cookies->video_quality) ? $plugin_cookies->video_quality : 'q720';

        hd_print("---> Target quality: $video_quality");

        $target_video_qualities = SmotroonApi::get_quality_array_vk($video_quality);
        end($target_video_qualities);
        $video_quality = intval(key($target_video_qualities));

        if ($video_quality > intval($vars['hd']))
            $video_quality = intval($vars['hd']);

        hd_print("---> Getting quality: $video_quality, because of max quality limit");

        if (array_key_exists('cache_base_' . $video_quality, $vars)) {

            $c = explode('/', $vars['cache_base_' . $video_quality]);
            if (count($c) == 2) {
                $url = 'http://cs' . $c[0] . '.vk.com/d' . $c[1] . '/' . $vars['cache_file_' . $video_quality] . '.' . $target_video_qualities[$video_quality] . '.mp4';
            } else {
                hd_print("---> Error! Cache contains url for target quality, but itsn't in suitable format.");
                return false;
            }
        }
        else
            $url = $vars['host'] . 'u' . self::get_uid6_vk($vars['uid']) . '/videos/' . $vars['vtag'] . '.' . $target_video_qualities[$video_quality] . '.mp4';

        hd_print("---> Result url: $url");
        return $url;
    }

    private static function get_uid6_vk($uid)
    {
        while (strlen($uid) < 5)
            $uid = "0" . $uid;

        return $uid;
    }
}