<?php

class YouTube {
    public static function getPlaybackUrl($url, &$plugin_cookies)
    {
        hd_print('---> Video from YouTube: $url');

        if (($url = SmotroonApi::getUrlFromIframe($url)) === false)
            return false;

        $url = 'http://www.youtube.com/get_video_info?video_id=' . self::getVideoId($url);

        $video_quality = isset($plugin_cookies->video_quality) ? $plugin_cookies->video_quality : 'q720';
        $target_video_qualities = SmotroonApi::get_quality_array_youtube($video_quality);

        try
        {
            $doc = HD::http_get_document($url);
        }
        catch(Exception $e)
        {
            hd_print("---> Connection error!!!");
            return false;
        }

        hd_print("---> Retrieving playback URL for $url...");

        if (stripos($doc, "status=fail")!==false) {
            hd_print("---> Video has been deleted");
            return false;
        }

        preg_match_all('/([^=&]*)=([^&]*)/', $doc, $pairs);
        $pairs = array_combine($pairs[1], $pairs[2]);
        $tmp = urldecode($pairs['url_encoded_fmt_stream_map']);

        $videos = explode(',', $tmp);

        $mp4_videos = array();
        //HD::print_r($videos);
        foreach ($videos as $video) {
            preg_match_all('/([^=&]*)=([^&]*)/', $video, $pairs);
            $pairs = array_combine($pairs[1], $pairs[2]);

            /*
            itag=5  - FLV 320 x 240
            itag=34 - FLV 640 x 360
            itag=35 - FLV 854 x 480
            itag=18 - MP4 640 x 360
            itag=22 - MP4 1280 x 720
            itag=37 - MP4 1920 x 1080
            itag=38 - MP4 4096 x 1714
            itag=43 - WEBM 640 x 360
            itag=44 - WEBM 854 x 480
            itag=45 - WEBM 1280 x 720
            */
            if (in_array($pairs['itag'], array(18, 22, 37, 38)))
            {
                $playback_url   = urldecode($pairs['url']) . "&signature=" . $pairs['sig'];

                $mp4_videos[] = $playback_url;

                //hd_print("--- playback_url: $playback_url");
                hd_print($pairs['quality']);
                if ($pairs['quality'] !== false && SmotroonApi::in_array_ci($pairs['quality'], $target_video_qualities) ) {
                    hd_print("---> Requested quality $video_quality. Returned " . $pairs['quality']);
                    return $playback_url;
                }
            }
        }
        if (count($mp4_videos) > 0) {
            hd_print("---> Requested quality is $video_quality, but returned higher.");
            return $mp4_videos[count($mp4_videos) - 1];
        }

        hd_print("---> Can't find mp4-stream");
        return false;
    }

    private static function getVideoId ($url) {
        return substr( strrchr( strstr($url,"?", true) ,"/") , 1);
    }
}